import React from 'react';
import { Form } from 'antd';
import Form2 from './Form';
import Item from './Item';
import { isFunction, isEmpty } from './utils';

function withForm(option = {}) {

  const createOption = {
    ...option,
    onValuesChange: (...args) => {

      if (isFunction(option.onValuesChange)) {
        option.onValuesChange(...args)
      }
      defaultListener(...args)
    }
  }

  let listeners = []

  function defaultListener(...args) {
    listeners.map(fn => fn(...args))
  }

  function handleFormChange (fn) {
    if (isFunction(fn)) {
      listeners.push(fn)
    }
  }

  class WrapperForm extends React.Component {
    renderChildren() {
      const { fields, form } = this.props;
  
      return (fields || []).filter(x => x).map((props, inx) => {  
        return (<Item key={inx} {...props} form={form} formChange={handleFormChange} />)
      })
    }

    render() {
      return (
        <Form2 {...this.props}>
          {this.renderChildren()}
        </Form2>
      )
    }
  }

  return Form.create(createOption)(WrapperForm)
}

export default withForm;
